import { __extends } from "tslib";
import { IgrCancelEventArgs } from "igniteui-react-core";
/**
 * Event arguments for the
 * hyperlinkExecuting event.
*/
var IgrSpreadsheetHyperlinkExecutingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSpreadsheetHyperlinkExecutingEventArgs, _super);
    function IgrSpreadsheetHyperlinkExecutingEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgrSpreadsheetHyperlinkExecutingEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSpreadsheetHyperlinkExecutingEventArgs.prototype, "hyperlink", {
        /**
         * Returns the hyperlink to be executed.
        */
        get: function () {
            return this.i.hyperlink;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSpreadsheetHyperlinkExecutingEventArgs.prototype, "workingDirectory", {
        /**
         * Returns or sets the working directory to use when the hyperlink is a file reference.
        */
        get: function () {
            return this.i.workingDirectory;
        },
        set: function (v) {
            this.i.workingDirectory = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrSpreadsheetHyperlinkExecutingEventArgs;
}(IgrCancelEventArgs));
export { IgrSpreadsheetHyperlinkExecutingEventArgs };
