import { SpreadsheetCommandExecutedEventArgs as SpreadsheetCommandExecutedEventArgs_internal } from "./SpreadsheetCommandExecutedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
import { SpreadsheetAction } from "./SpreadsheetAction";
/**
 * Event arguments for the
 * actionExecuted event.
*/
export declare class IgrSpreadsheetActionExecutedEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): SpreadsheetCommandExecutedEventArgs_internal;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Returns the command which was executed on the
     * Spreadsheet.
    */
    get command(): SpreadsheetAction;
    /**
     * Returns the parameter used when executing the command.
    */
    get commandParameter(): any;
}
