import { SpreadsheetActiveCellChangedEventArgs as SpreadsheetActiveCellChangedEventArgs_internal } from "./SpreadsheetActiveCellChangedEventArgs";
import { ContentChildrenManager } from "igniteui-react-core";
import { SpreadsheetCell } from "./SpreadsheetCell";
/**
 * Event arguments for the
 * activeCellChanged event.
*/
export declare class IgrSpreadsheetActiveCellChangedEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): SpreadsheetActiveCellChangedEventArgs_internal;
    private onImplementationCreated;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Returns the new value of the
     * activeCell
    */
    get newValue(): SpreadsheetCell;
    /**
     * Returns the previous value of the
     * activeCell
    */
    get oldValue(): SpreadsheetCell;
}
