import { IgrCancelEventArgs } from "igniteui-react-core";
import { SpreadsheetEditModeEnteringEventArgs as SpreadsheetEditModeEnteringEventArgs_internal } from "./SpreadsheetEditModeEnteringEventArgs";
import { SpreadsheetCell } from "./SpreadsheetCell";
/**
 * Event arguments for the
 * editModeEntering event.
*/
export declare class IgrSpreadsheetEditModeEnteringEventArgs extends IgrCancelEventArgs {
    /**
                                 * @hidden
                                 */
    get i(): SpreadsheetEditModeEnteringEventArgs_internal;
    constructor();
    /**
     * Returns the cell for which the control is going into edit mode.
    */
    get cell(): SpreadsheetCell;
}
