import { __extends } from "tslib";
import { IgrCancelEventArgs } from "igniteui-react-core";
/**
 * Event arguments for the
 * actionExecuting event.
*/
var IgrSpreadsheetActionExecutingEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSpreadsheetActionExecutingEventArgs, _super);
    function IgrSpreadsheetActionExecutingEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgrSpreadsheetActionExecutingEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSpreadsheetActionExecutingEventArgs.prototype, "command", {
        /**
         * Returns the command which will be executed on the
         * Spreadsheet.
        */
        get: function () {
            return this.i.command;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSpreadsheetActionExecutingEventArgs.prototype, "commandParameter", {
        /**
         * Returns the parameter which will be used when executing the command.
        */
        get: function () {
            return this.i.commandParameter;
        },
        enumerable: false,
        configurable: true
    });
    return IgrSpreadsheetActionExecutingEventArgs;
}(IgrCancelEventArgs));
export { IgrSpreadsheetActionExecutingEventArgs };
