/**
 * Event arguments for the
 * editModeExited event.
*/
var IgrSpreadsheetEditModeExitedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrSpreadsheetEditModeExitedEventArgs() {
    }
    Object.defineProperty(IgrSpreadsheetEditModeExitedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSpreadsheetEditModeExitedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrSpreadsheetEditModeExitedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrSpreadsheetEditModeExitedEventArgs.prototype, "cell", {
        /**
         * Returns the cell for which the control has exitied edit mode.
        */
        get: function () {
            return this.i.cell;
        },
        enumerable: false,
        configurable: true
    });
    return IgrSpreadsheetEditModeExitedEventArgs;
}());
export { IgrSpreadsheetEditModeExitedEventArgs };
