import { __extends } from "tslib";
import { IgrCancelEventArgs } from "igniteui-react-core";
/**
 * Event arguments for the
 * editRangePasswordNeeded event.
*/
var IgrSpreadsheetEditRangePasswordNeededEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrSpreadsheetEditRangePasswordNeededEventArgs, _super);
    function IgrSpreadsheetEditRangePasswordNeededEventArgs() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgrSpreadsheetEditRangePasswordNeededEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSpreadsheetEditRangePasswordNeededEventArgs.prototype, "ranges", {
        /**
         * Returns the collection of protected ranges that should be unlocked.
         * This collection contains the protected ranges that overlap with the
         * locked cells that need to be unlocked. There may be multiple ranges that overlap the locked
         * cells so it may not be that every range needs to be unlocked.
        */
        get: function () {
            return this.i.ranges;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Unlocks the associated range(s) without validating the password.
    
    */
    IgrSpreadsheetEditRangePasswordNeededEventArgs.prototype.unprotect = function () {
        this.i.unprotect();
    };
    return IgrSpreadsheetEditRangePasswordNeededEventArgs;
}(IgrCancelEventArgs));
export { IgrSpreadsheetEditRangePasswordNeededEventArgs };
