import { Base, Type } from "igniteui-react-core";
/**
 * An object that contains a DataValue and DisplayText for lists (such as ComboBoxes) in the UI.
 */
export declare class ComboBoxListItem extends Base {
    static $t: Type;
    private _a;
    private _e;
    private _c;
    constructor(dataValue: any, displayText: string);
    /**
     * The data value of the item.
     */
    get dataValue(): any;
    set dataValue(a: any);
    /**
     * The text to display for the item.
     */
    get displayText(): string;
    set displayText(a: string);
    /**
     * an object that stores extra data related to the item.
     */
    get tag(): any;
    set tag(a: any);
    /**
     * Returns a string that represents the current object.
     * @return A string that represents the current object.
     */
    toString(): string;
}
